


use strict;

use Data::Dumper;
use LWP::UserAgent;
use LWP::Debug;
use SOAP::Lite on_action => sub { "$_[0]$_[1]"; };
use Time::Local;


import SOAP::Data 'name', 'value';



my $sp_endpoint = 'https://mysphost/sites/demo/_vti_bin/lists.asmx';
my $sp_domain   = 'mysphost:443';
my $sp_username = 'mydomain\\myuserid';
my $sp_password = 'mypasswd';


my $debug = 1;

if ($debug) {
    LWP::Debug::level('+');
    SOAP::Lite->import(+trace => 'all');
}


my @ua_args     = (keep_alive => 1);
my @credentials = ($sp_domain, "", $sp_username, $sp_password);
my $schema_ua   = LWP::UserAgent->new(@ua_args);

#$schema_ua->default_header('WWW-Authenticate' => "NTLM");

$schema_ua->credentials(@credentials);

my $soap = SOAP::Lite->proxy($sp_endpoint, 
                             @ua_args, 
                             credentials => \@credentials);
$soap->schema->useragent($schema_ua);
$soap->uri("http://schemas.microsoft.com/sharepoint/soap/");




my $lib_title    = "MyLibrary";
#my $lib_id       = qq{B6DD8E45-7E39-46B8-AE93-69360313D69A});
#my $lib_id       = qq({2F7C4C28-4EAA-4796-9E54-4EDDDADB81C5});
my $lib_id       = qq({E24716E7-9CCA-47FD-81F7-425749B0EF8D});
my $item_name    = "graph1.pdf";
my $item_id      = 1;



#----------------------------------------------------------------------
# Update a single Item
#----------------------------------------------------------------------
# <Method ID='1' Cmd='Update'>
#    <Field Name = 'ID'>4</Field>
#    <Field Name = 'bhtest1'>12345</Field>
# </Method>
#
#
#
#-----------------------------------------------------
my $field_id = SOAP::Data->name('Field', $item_id)
    ->attr({ Name => 'ID'});

$field_id->type("string");

print "FIELD ID      = $field_id\n";

my $field_bhtest1 = SOAP::Data->name('Field', "ZZZ")
    ->attr({ Name => 'abcxyz'});

print "FIELD BHTEST1 = $field_bhtest1\n";

my $method = SOAP::Data->name('Method', [$field_id, $field_bhtest1])
    ->attr({ ID => 1, Cmd => 'Update'});

print "METHOD        = $method\n";


my $batch = SOAP::Data->name('Batch', \$method);

print "BATCH         = $batch\n";
print "LIB ID        = $lib_id\n";
print "ITEM ID       = $item_id\n";


my $call = $soap->UpdateListItems(SOAP::Data->name('listName' => $lib_id),
                                  SOAP::Data->name('updates' => \$batch));

print "CALL          = $call\n";


quit(1, $call->faultstring()) if defined $call->fault();









print "DONE\n\n\n";
