


use strict;

use Data::Dumper;
use LWP::UserAgent;
use LWP::Debug;
use SOAP::Lite on_action => sub { "$_[0]$_[1]"; };
use Time::Local;


import SOAP::Data 'name', 'value';



my $sp_endpoint = 'https://mysphost/sites/demo/_vti_bin/lists.asmx';
my $sp_domain   = 'mysphost:443';
my $sp_username = 'mydomain\\myuserid';
my $sp_password = 'mypasswd';


my $debug = 1;

if ($debug) {
    LWP::Debug::level('+');
    SOAP::Lite->import(+trace => 'all');
}


my @ua_args     = (keep_alive => 1);
my @credentials = ($sp_domain, "", $sp_username, $sp_password);
my $schema_ua   = LWP::UserAgent->new(@ua_args);

#$schema_ua->default_header('WWW-Authenticate' => "NTLM");

$schema_ua->credentials(@credentials);

my $soap = SOAP::Lite->proxy($sp_endpoint, 
                             @ua_args, 
                             credentials => \@credentials);
$soap->schema->useragent($schema_ua);
$soap->uri("http://schemas.microsoft.com/sharepoint/soap/");

my $lib_id       = qq({B6DD8E45-7E39-46B8-AE93-69360313D69A});
#my $lib_id       = qq({E24716E7-9CCA-47FD-81F7-425749B0EF8D});
my $item_id      = 4;
my $item_ref     = qq(https://mysphost/sites/demo/My Test Library/person1.txt);


#----------------------------------------------------------------------
# Update a single Item
#----------------------------------------------------------------------
# <Method ID='1' Cmd='Update'>
#    <Field Name = 'ID'>4</Field>
#    <Field Name = 'bhtest1'>12345</Field>
# </Method>
#
#
#
#-----------------------------------------------------
my $fid    = SOAP::Data->name('Field', $item_id)->attr({ Name => 'ID'});
my $ffref  = SOAP::Data->name('Field', $item_ref)->attr({ Name => 'FileRef'});
my $ftitle = SOAP::Data->name('Field', "ABCIJKXYZ")->attr({ Name => 'bhtest1'});

#$fid->type("string");

my $method = 
    SOAP::Data->name('Method', [$fid, $ffref, $ftitle])->
    attr({ ID  => 1, 
           Cmd => 'Update'});

my $batch = SOAP::Data->name('Batch', \$method);

my $call = $soap->UpdateListItems(SOAP::Data->name('listName' => $lib_id),
                                  SOAP::Data->name('updates' => \$batch));

print "CALL = $call\n\n\n";
print $call->faultstring . "\n";
print "\n\n\n";

#quit(1, $call->faultstring()) if defined $call->fault();


print "DONE\n\n\n";
